## kdiff3 1.8.4

=== debian/changelog ===
kdiff3 (1.8.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Fix day-of-week for changelog entries 0.9.97-2, 0.9.96-4, 0.9.95-5,
    0.9.95-4, 0.9.94-3, 0.9.94-2, 0.9.93-3-1, 0.9.92-3, 0.9.92-2, 0.9.90-5,
    0.9.90-4, 0.9.90-3, 0.9.90-2, 0.9.88-5.

  [ Pino Toscano ]
  * New upstream release.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
  * Change the kdiff3 recommend in kdiff3-qt to a dependency, to make sure
    that the transitional package actually works as such.
  * Switch Source in copyright to https://invent.kde.org/sdk/kdiff3.
  * Remove the explicit as-needed linking, as it is done by binutils now.

 -- Pino Toscano <pino@debian.org>  Fri, 04 Sep 2020 11:55:08 +0200

kdiff3 (1.8.3-1) unstable; urgency=medium

  * New upstream release:
    - fixes handling of the -L command line option (Closes: #939017)
    - fixes missing menu items (Closes: #962960)
  * Update the build dependencies according to the upstream build system:
    - bump the KF packages to 5.27.0
  * Update the patches:
    - upstream_Don-t-try-to-set-value-unless-scrollbar-exists.patch: drop,
      backported from upstream
    - libatomic.diff: refresh
  * Add the upstream signing key.
  * Do not ship the diff_ext.mo translations, as they are for a component
    specific for Windows.

 -- Pino Toscano <pino@debian.org>  Sun, 05 Jul 2020 08:17:21 +0200

kdiff3 (1.8.01-2) unstable; urgency=medium

  * Switch the maintainer to Debian KDE Extras Team, as agreed with Eike;
    keep him as Uploader, and add myself too.
  * Drop the local man page, since upstream already provides one, so our
    version overwrites it:
    - remove kdiff3.sgml
    - remove the docbook-to-man build dependency
  * Do not use dh_icons anymore, as there are already file triggers to update
    the icon theme caches.
  * Add Vcs-* fields.
  * Stop generating the HTML documentation, as it is generally not shipped
    for KDE applications: (Closes: #924187)
    - drop kdiff3-doc.doc-base, and kdiff3-doc.links
  * Do not try to ship README.Debian, and README.source as documentation for
    kdiff3-docs, as these files do not exist
    - drop kdiff3-docs.docs
  * Stop installing the NEWS file as documentation for kdiff3, as this file
    only points to ChangeLog.
  * Add the configuration for the CI on salsa.
  * Sort, and clean the install files.
  * Update the build dependencies according to the upstream build system:
    - add the version required for cmake, extra-cmake-modules, Qt5, and the
      KF5 packages
    - explicitly add gettext, libkf5config-dev, libkf5kio-dev, and
      libkf5widgetsaddons-dev
  * Switch from cdbs to the dh sequencer with the kf5 dh addon
    - replace the cdbs build dependency with pkg-kde-tools
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
  * Rename debian/docs to debian/kdiff3.docs, to make to explicit which package
    it refers to.
  * Add Rules-Requires-Root: no.
  * Remove unused lintian override.
  * Remove the trailing whitespaces in changelog, and control.
  * Ship also the translations. (Closes: #932887)
  * Use https for Format in copyright.
  * Bump Standards-Version to 4.5.0, no changes required.
  * Add a watch file.
  * Replace the patch fix-crash.patch with the upstream commit
    6fd52582694f5616df3ec135fe22f21fc281036d; patch
    upstream_Don-t-try-to-set-value-unless-scrollbar-exists.patch.
  * Slightly rework the descriptions.

 -- Pino Toscano <pino@debian.org>  Tue, 30 Jun 2020 07:07:37 +0200

=== debian/control ===
Source: kdiff3
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Eike Sauer <eike@debian.org>,
 Pino Toscano <pino@debian.org>,
Section: kde
Priority: optional
Build-Depends: debhelper-compat (= 13),
 pkg-kde-tools,
 gettext,
 cmake (>= 3.1~),
 extra-cmake-modules (>= 5.10.0~),
 qtbase5-dev (>= 5.6.0~),
 libkf5config-dev (>= 5.27.0~),
 libkf5coreaddons-dev (>= 5.27.0~),
 libkf5crash-dev (>= 5.27.0~),
 libkf5doctools-dev (>= 5.27.0~),
 libkf5iconthemes-dev (>= 5.27.0~),
 libkf5i18n-dev (>= 5.27.0~),
 libkf5kio-dev (>= 5.27.0~),
 libkf5parts-dev (>= 5.27.0~),
 libkf5widgetsaddons-dev (>= 5.27.0~),
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://kde.org/applications/development/kdiff3
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdiff3
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdiff3.git

Package: kdiff3
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: kdiff3-doc
Breaks: kdiff3-qt (<<1.0)
Replaces: kdiff3-qt (<<1.0)
Description: compares and merges 2 or 3 files or directories
 KDiff3 compares two or three input files and shows the differences
 line by line and character by character. It provides an automatic
 merge facility and an integrated editor for comfortable solving of
 merge conflicts. KDiff3 allows recursive directory comparison and
 merging as well. KDiff3 also has KIO support, so it can access to
 remote files and compressed archives.

Package: kdiff3-qt
Architecture: all
Multi-Arch: foreign
Depends: kdiff3 (>= ${source:Version}), ${misc:Depends},
Section: oldlibs
Description: transistional package for kdiff3
 This is a transitional package. It can safely be removed.
 .
 This version of KDiff3 is not developed anymore, replaced by kdiff3.

Package: kdiff3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Recommends: kdiff3
Breaks: kdiff3 (<= 1.7.90-1)
Replaces: kdiff3 (<= 1.7.90-1)
Description: documentation for KDiff3
 KDiff3 compares two or three input files and shows the differences
 line by line and character by character.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with kf5

override_dh_auto_install:
	dh_auto_install
	# drop translations of Windows-only component
	rm debian/tmp/usr/share/locale/*/LC_MESSAGES/diff_ext.mo

## kdiff3 1.8.5

=== CMakeLists.txt ===
#cmake < 3.1 has no sane way of checking C++11 features and needed flags
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

project(kdiff3)

set(CMAKE_CXX_EXTENSIONS ON ) #disable trigraphs in clang/gcc -- officially removed in c++17
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(ECM_MIN_VERSION "5.10.0")
set(QT_MIN_VERSION "5.6.0")
#KF5 5.27 fixes a crash bug triggered on exit.
set(KF5_MIN_VERSION "5.27.0")

find_package(ECM ${ECM_MIN_VERSION} CONFIG REQUIRED)
set(
    CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${ECM_MODULE_PATH}
)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(FeatureSummary)

include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)

ecm_setup_version(1.8.5 VARIABLE_PREFIX KDIFF3 VERSION_HEADER ${CMAKE_BINARY_DIR}/src/version.h)

find_package(
    Qt5 ${QT_MIN_VERSION}
    CONFIG
    REQUIRED
    COMPONENTS
    Core
    Gui
    Widgets
    PrintSupport
)

find_package(
    KF5 ${KF5_MIN_VERSION}
    REQUIRED
    COMPONENTS
    I18n
    CoreAddons
    Crash
    DocTools
    IconThemes
)

option(ENABLE_AUTO "Enable kdiff3's '--auto' flag" ON)
option(ENABLE_CLANG_TIDY "Run clang-tidy if available and cmake version >=3.6" OFF)

set(KDiff3_LIBRARIES ${Qt5PrintSupport_LIBRARIES} KF5::I18n KF5::CoreAddons KF5::Crash KF5::IconThemes )

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    #Adjust clang specific  warnings
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wshadow")
    set(CLANG_WARNING_FLAGS "-Wno-trigraphs -Wno-invalid-pp-token -Wno-comment -Wshorten-64-to-32 -Wstring-conversion -Wc++11-narrowing -fstack-protector-all")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${CLANG_WARNING_FLAGS}")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    add_definitions(-DNOMINMAX) #Suppress MSVCs min/max macros
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-check")
    endif()
    if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7.0)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-trigraphs -Wduplicated-cond -Wduplicated-branches -Wshadow")
    endif()
endif()

#new in cmake 3.6+ integrate clang-tidy
if(ENABLE_CLANG_TIDY AND NOT ${CMAKE_VERSION} VERSION_LESS "3.6.0")
    find_program(CLANG_TIDY_EXE NAMES "clang-tidy" "clang-tidy-7" "clang-tidy-6.0" "clang-tidy-6" DOC "Path to clang-tidy executable")
    if(NOT CLANG_TIDY_EXE)
        message(STATUS "clang-tidy not found disabling integration.")
    else()
        message(STATUS "Found clang-tidy: ${CLANG_TIDY_EXE}")
        set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE}" "-header-filter=.*")
    endif()
endif()

set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} ${CMAKE_CXX_FLAGS}")

set(
    needed_features
    cxx_nullptr
    cxx_override
    cxx_nonstatic_member_init
    cxx_inheriting_constructors
    cxx_static_assert
)

if(ENABLE_AUTO)
    add_definitions(
        -DENABLE_AUTO
    )
endif()

add_definitions(
    -DQT_DEPRECATED_WARNINGS #Get warnings from QT about deprecated functions.
    -DQT_NO_URL_CAST_FROM_STRING # casting from string to url does not always behave as you might think
    -DQT_RESTRICTED_CAST_FROM_ASCII #casting from char*/QByteArray to QString can produce unexpected results for non-latin characters.
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_PROCESS_COMBINED_ARGUMENT_START
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050600#disable depriated api for Qt<5.6.
    #KF5 5.64+ flags
    #Don't warn for API depreciated after 5.27.0 (below as hex.hex.hex number)
    -DKF_DEPRECATED_WARNINGS_SINCE=0x051A00
)

add_subdirectory(src)
add_subdirectory(doc)

add_subdirectory(kdiff3fileitemactionplugin)

ki18n_install(po)
kdoctools_install(po)

if(WIN32)
add_subdirectory(diff_ext_for_kdiff3)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== diff_ext_for_kdiff3/CMakeLists.txt ===

# Work around buggy windows sdk headers that prevent certain symbols from being exported the normal way
# even though they are required exports for shell exentions.
if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
set(kdiff3extdefs diff_ext_for_kdiff3_msvc.def)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
set(kdiff3extdefs diff_ext_for_kdiff3.def)
endif()

set(kdiff3ext_SRCS
    class_factory.cpp
    diff_ext.cpp
    server.cpp
    ${kdiff3extdefs}
)

set_source_files_properties(${kdiff3extdefs} PROPERTIES HEADER_FILE_ONLY TRUE)

set(kdiff3ext_RCS
    diff_ext_for_kdiff3.rc
)

add_library(kdiff3ext MODULE ${kdiff3ext_SRCS} ${kdiff3ext_RCS})

target_link_libraries(kdiff3ext KF5::I18n uuid ole32)
target_compile_definitions(kdiff3ext PRIVATE -DTRANSLATION_DOMAIN=\"kdiff3\" -DUNICODE=1 -DWINVER=0x0502 -D_WIN32_WINNT=WINVER)

#If we don't do this the nsi packer won't pickup the shell extention library.
install(TARGETS kdiff3ext DESTINATION  ${KDE_INSTALL_PLUGINDIR}/kf5 )

=== src/CMakeLists.txt ===


########### kdiff3 KPart ###############
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS Parts WidgetsAddons)

set(kdiff3part_PART_SRCS
   kdiff3_part.cpp
   kdiff3.cpp
   directorymergewindow.cpp
   merger.cpp
   pdiff.cpp
   difftextwindow.cpp
   diff.cpp
   optiondialog.cpp
   mergeresultwindow.cpp
   fileaccess.cpp
   gnudiff_analyze.cpp
   gnudiff_io.cpp
   gnudiff_xmalloc.cpp
   common.cpp
   smalldialogs.cpp
   progress.cpp
   ProgressProxyExtender.cpp
   PixMapUtils.cpp
   MergeFileInfos.cpp
   Utils.cpp
   selection.cpp
   cvsignorelist.cpp
   SourceData.cpp
   Overview.cpp
   Logging.cpp
   FileNameLineEdit.cpp )

ki18n_wrap_ui(kdiff3part_PART_SRCS
    scroller.ui
)

add_library(kdiff3part MODULE ${kdiff3part_PART_SRCS})

set_target_properties(kdiff3part PROPERTIES DEFINE_SYMBOL KDIFF3_PART)
target_compile_features(kdiff3part PRIVATE ${needed_features})
target_link_libraries(kdiff3part ${KDiff3_LIBRARIES} KF5::Parts KF5::Crash)
target_compile_definitions(kdiff3part PRIVATE -DTRANSLATION_DOMAIN=\"kdiff3\")

install(TARGETS kdiff3part DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf5/parts )

########### kdiff3 executable ###############
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS Parts WidgetsAddons Config)

set(kdiff3_SRCS
   main.cpp
   kdiff3_shell.cpp
   ${kdiff3part_PART_SRCS}
    )

#cann't use add_subdirectory because it changes the scope.
include(icons/CMakeLists.txt)
add_executable(kdiff3 ${kdiff3_SRCS})

target_link_libraries(kdiff3 KF5::ConfigCore KF5::ConfigGui KF5::Parts KF5::Crash ${KDiff3_LIBRARIES} )
target_compile_features(kdiff3 PRIVATE ${needed_features})

# See https://cmake.org/cmake/help/v3.15/prop_tgt/MACOSX_BUNDLE_INFO_PLIST.html
if(APPLE)
  set_property(
    TARGET kdiff3
    PROPERTY MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in
  )

  # These are substituted by CMake into plist.in.
  set(MACOSX_BUNDLE_DISPLAY_NAME "KDiff3")
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.KDiff3")
  set(MACOSX_BUNDLE_BUNDLE_NAME "KDiff3")
  set(MACOSX_BUNDLE_DISPLAY_NAME "KDiff3")
  set(MACOSX_BUNDLE_INFO_STRING "KDiff3 - Diff/Patch Frontend")
  set(MACOSX_BUNDLE_LONG_VERSION_STRING "KDiff3 ${KDIFF3_VERSION}")
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${KDIFF3_VERSION_MAJOR}.${KDIFF3_VERSION_MINOR}")
  set(MACOSX_BUNDLE_BUNDLE_VERSION "${KDIFF3_VERSION}")
  set(MACOSX_BUNDLE_COPYRIGHT "2003-2020 The KDiff3 Authors")
endif()

install(TARGETS kdiff3 ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})


########### install files ###############

install( FILES  kdiff3part.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR} )
install( FILES  kdiff3_part.rc DESTINATION ${KDE_INSTALL_KXMLGUI5DIR}/kdiff3part )
install( FILES  kdiff3_shell.rc DESTINATION ${KDE_INSTALL_KXMLGUI5DIR}/kdiff3 )
#install( PROGRAMS  kdiff3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )
install( PROGRAMS org.kde.kdiff3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )
install( FILES org.kde.kdiff3.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )

=== src/icons/CMakeLists.txt ===
set(KDIFF3_PNG_ICONS
     icons/16-apps-kdiff3.png
     icons/22-apps-kdiff3.png
     icons/32-apps-kdiff3.png
     icons/48-apps-kdiff3.png
     icons/64-apps-kdiff3.png
     icons/128-apps-kdiff3.png
     icons/256-apps-kdiff3.png)

set(KDIFF3_ICONS
     ${KDIFF3_PNG_ICONS}
     icons/sc-apps-kdiff3.svgz
)

# add icons to application sources, to have them bundled -- must be in same scope as src/CMakeLists.txt
ecm_add_app_icon(kdiff3_SRCS ICONS ${KDIFF3_PNG_ICONS})

ecm_install_icons(
  ICONS
   ${KDIFF3_ICONS}
  DESTINATION ${KDE_INSTALL_ICONDIR}
  THEME hicolor
)

=== debian/changelog ===
kdiff3 (1.8.5-1) unstable; urgency=medium

  * New upstream release.
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Bump Standards-Version to 4.5.1, no changes required.
  * Use execute_after_dh_auto_install to avoid invoking dh_auto_install
    manually.

 -- Pino Toscano <pino@debian.org>  Thu, 21 Jan 2021 11:40:18 +0100

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libkf5kio-dev (>= 5.27.0~),
  libkf5parts-dev (>= 5.27.0~),
  libkf5widgetsaddons-dev (>= 5.27.0~),
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://kde.org/applications/development/kdiff3
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdiff3

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,6 @@
 %:
 	dh $@ --with kf5
 
-override_dh_auto_install:
-	dh_auto_install
+execute_after_dh_auto_install:
 	# drop translations of Windows-only component
 	rm debian/tmp/usr/share/locale/*/LC_MESSAGES/diff_ext.mo

## kdiff3 1.9.3

=== debian/changelog ===
kdiff3 (1.9.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Aug 2021 07:38:38 +0200

kdiff3 (1.9.2-2) unstable; urgency=medium

  * Replace patch libatomic.diff by specifying -latomic instead via
    dpkg-buildflags, making sure it cannot be left out by as-needed;
    for now this is done on: armel m68k mipsel powerpc sh4.
    Hopefully, this should fix linking the atomic functions.

 -- Pino Toscano <pino@debian.org>  Mon, 16 Aug 2021 06:31:39 +0200

kdiff3 (1.9.2-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.8
    - bump the Qt packages to 5.8.0
    - bump the KF packages to 5.37.0
    - add libboost-dev
    - drop libkf5iconthemes-dev
  * Update the patches:
    - libatomic.diff: refresh/update
  * There are unit tests that require a display, so:
    - add the xauth, and xvfb build dependencies
    - run dh_auto_test with xvfb-run
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Sun, 15 Aug 2021 17:31:23 +0200

=== debian/control ===
--- 
+++ 
@@ -7,19 +7,21 @@
 Build-Depends: debhelper-compat (= 13),
  pkg-kde-tools,
  gettext,
- cmake (>= 3.1~),
+ cmake (>= 3.8~),
  extra-cmake-modules (>= 5.10.0~),
- qtbase5-dev (>= 5.6.0~),
- libkf5config-dev (>= 5.27.0~),
- libkf5coreaddons-dev (>= 5.27.0~),
- libkf5crash-dev (>= 5.27.0~),
- libkf5doctools-dev (>= 5.27.0~),
- libkf5iconthemes-dev (>= 5.27.0~),
- libkf5i18n-dev (>= 5.27.0~),
- libkf5kio-dev (>= 5.27.0~),
- libkf5parts-dev (>= 5.27.0~),
- libkf5widgetsaddons-dev (>= 5.27.0~),
-Standards-Version: 4.5.1
+ qtbase5-dev (>= 5.8.0~),
+ libkf5config-dev (>= 5.37.0~),
+ libkf5coreaddons-dev (>= 5.37.0~),
+ libkf5crash-dev (>= 5.37.0~),
+ libkf5doctools-dev (>= 5.37.0~),
+ libkf5i18n-dev (>= 5.37.0~),
+ libkf5kio-dev (>= 5.37.0~),
+ libkf5parts-dev (>= 5.37.0~),
+ libkf5widgetsaddons-dev (>= 5.37.0~),
+ libboost-dev (>= 1.66.0~),
+ xauth,
+ xvfb,
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://kde.org/applications/development/kdiff3
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdiff3

## kdiff3 1.9.5

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

#cmake < 3.1 has no sane way of checking C++11 features and needed flags
#need at least 3.8 for cxx_std_11.
cmake_minimum_required(VERSION 3.8 FATAL_ERROR)

project(kdiff3)

set(CMAKE_CXX_EXTENSIONS ON ) #disable trigraphs in clang/gcc -- officially removed in c++17
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(ECM_MIN_VERSION "5.10.0")
set(QT_MIN_VERSION "5.8.0")
#KF5 5.27 fixes a crash bug triggered on exit.
set(KF5_MIN_VERSION "5.37.0")

find_package(ECM ${ECM_MIN_VERSION} CONFIG REQUIRED)
set(
    CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${ECM_MODULE_PATH}
)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(FeatureSummary)

include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)

ecm_setup_version(1.9.5 VARIABLE_PREFIX KDIFF3 VERSION_HEADER ${CMAKE_BINARY_DIR}/src/version.h)

# Some older versions on boost contain a bug that prevents compiling gcc offers a built-in workaround
# but that isn't enough to ship as clang has no such workaround. 1.65 is known to be affected.
find_package(Boost 1.66 REQUIRED)

#needed on craft and possiablely other custom setups.
include_directories(${Boost_INCLUDE_DIRS})

find_package(
    Qt5 ${QT_MIN_VERSION}
    CONFIG
    REQUIRED
    COMPONENTS
    Core
    Gui
    Widgets
    PrintSupport
)

find_package(
    KF5 ${KF5_MIN_VERSION}
    REQUIRED
    COMPONENTS
    I18n
    CoreAddons
    Crash
    OPTIONAL_COMPONENTS
    DocTools
)

set_package_properties(KF5DocTools PROPERTIES PURPOSE "Allows generating and installing docs.")

option(ENABLE_AUTO "Enable kdiff3's '--auto' flag" ON)
option(ENABLE_CLANG_TIDY "Run clang-tidy if available and cmake version >=3.6" OFF)

set(KDiff3_LIBRARIES ${Qt5PrintSupport_LIBRARIES} KF5::I18n KF5::CoreAddons )

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    #Adjust clang specific  warnings
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wshadow")
    set(CLANG_WARNING_FLAGS "-Wno-undef -Wno-trigraphs -Wno-invalid-pp-token -Wno-comment -Wshorten-64-to-32 -Wstring-conversion -Wc++11-narrowing -fstack-protector-all")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${CLANG_WARNING_FLAGS}")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    add_compile_options("/EHs")
    add_definitions(-DNOMINMAX) #Suppress MSVCs min/max macros
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-check")
    endif()
    if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7.0)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-trigraphs -Wduplicated-cond -Wduplicated-branches -Wshadow")
    endif()
endif()

#new in cmake 3.6+ integrate clang-tidy
if(ENABLE_CLANG_TIDY)
    find_program(CLANG_TIDY_EXE NAMES "clang-tidy" "clang-tidy-7" "clang-tidy-6.0" "clang-tidy-6" DOC "Path to clang-tidy executable")
    if(NOT CLANG_TIDY_EXE)
        message(STATUS "clang-tidy not found disabling integration.")
    else()
        message(STATUS "Found clang-tidy: ${CLANG_TIDY_EXE}")
        set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE}" "-header-filter=.*")
    endif()
endif()

set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} ${CMAKE_CXX_FLAGS}")

set(
    needed_features
    cxx_std_11
)

if(ENABLE_AUTO)
    add_definitions(
        -DENABLE_AUTO
    )
endif()

add_definitions(
    -DQT_DEPRECATED_WARNINGS #Get warnings from QT about deprecated functions.
    -DQT_NO_URL_CAST_FROM_STRING # casting from string to url does not always behave as you might think
    -DQT_RESTRICTED_CAST_FROM_ASCII #casting from char*/QByteArray to QString can produce unexpected results for non-latin characters.
    -DQT_NO_KEYWORDS
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_PROCESS_COMBINED_ARGUMENT_START
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050800#disable deprecated api for Qt<5.8.
    #Boost 1.74 and possibly others trigger these warnings in boosts own internal headers making
    #the warning useless.
    -DBOOST_ALLOW_DEPRECATED_HEADERS
    #KF5 5.64+ flags
    #Don't warn for API depreciated after 5.36.0 (below as hex.hex.hex number)
    -DKF_DEPRECATED_WARNINGS_SINCE=0x052400
    -DKIOCORE_DEPRECATED_WARNINGS_SINCE=0x052400
)

add_subdirectory(src)
if(KF5DocTools_FOUND)
    add_subdirectory(doc)
    kdoctools_install(po)
else()
    message(WARNING "DocTools not found.")
endif()

ki18n_install(po)

add_subdirectory(kdiff3fileitemactionplugin)

if(WIN32)
add_subdirectory(diff_ext_for_kdiff3)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== diff_ext_for_kdiff3/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-
 # Work around buggy windows sdk headers that prevent certain symbols from being exported the normal way
 # even though they are required exports for shell exentions.
 if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
@@ -23,7 +22,7 @@
 add_library(kdiff3ext MODULE ${kdiff3ext_SRCS} ${kdiff3ext_RCS})
 
 target_link_libraries(kdiff3ext KF5::I18n uuid ole32)
-target_compile_definitions(kdiff3ext PRIVATE -DTRANSLATION_DOMAIN=\"kdiff3\" -DUNICODE=1 -DWINVER=0x0502 -D_WIN32_WINNT=WINVER)
+target_compile_definitions(kdiff3ext PRIVATE -DTRANSLATION_DOMAIN=\"kdiff3\" -DUNICODE=1 -Dkdiff3ext)
 
 #If we don't do this the nsi packer won't pickup the shell extention library.
-install(TARGETS kdiff3ext DESTINATION  ${KDE_INSTALL_PLUGINDIR}/kf5 )
+install(TARGETS kdiff3ext DESTINATION  ${KDE_INSTALL_PLUGINDIR} )

=== kdiff3fileitemactionplugin/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdiff3fileitemactionplugin\")

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS KIO
	  WidgetsAddons   # KMessageBox
	)

set(kdiff3_fileitemaction_src kdiff3fileitemaction.cpp ../src/Utils.cpp ../src/ignorelist.cpp ../src/fileaccess.cpp ../src/DefaultFileAccessJobHandler.cpp ../src/progress.cpp ../src/ProgressProxyExtender.cpp ../src/Logging.cpp)

kcoreaddons_add_plugin(kdiff3fileitemaction SOURCES ${kdiff3_fileitemaction_src} JSON kdiff3fileitemaction.json INSTALL_NAMESPACE "kf5/kfileitemaction")
target_link_libraries(kdiff3fileitemaction KF5::I18n KF5::WidgetsAddons KF5::KIOWidgets)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
-
+# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
+# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
+# SPDX-License-Identifier: GPL-2.0-or-later
 
 ########### kdiff3 KPart ###############
 find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS Parts WidgetsAddons)
@@ -6,6 +8,7 @@
 set(kdiff3part_PART_SRCS
    kdiff3_part.cpp
    kdiff3.cpp
+   DirectoryInfo.cpp
    directorymergewindow.cpp
    merger.cpp
    pdiff.cpp
@@ -14,6 +17,7 @@
    optiondialog.cpp
    mergeresultwindow.cpp
    fileaccess.cpp
+   DefaultFileAccessJobHandler.cpp
    gnudiff_analyze.cpp
    gnudiff_io.cpp
    gnudiff_xmalloc.cpp
@@ -25,14 +29,18 @@
    MergeFileInfos.cpp
    Utils.cpp
    selection.cpp
-   cvsignorelist.cpp
+   ignorelist.cpp
    SourceData.cpp
    Overview.cpp
    Logging.cpp
-   FileNameLineEdit.cpp )
+   FileNameLineEdit.cpp
+   MergeEditLine.cpp
+   Options.cpp
+   CommentParser.cpp )
 
 ki18n_wrap_ui(kdiff3part_PART_SRCS
     scroller.ui
+    opendialog.ui
 )
 
 add_library(kdiff3part MODULE ${kdiff3part_PART_SRCS})
@@ -53,6 +61,9 @@
    ${kdiff3part_PART_SRCS}
     )
 
+if(BUILD_TESTING)
+   add_subdirectory( autotests )
+endif()
 #cann't use add_subdirectory because it changes the scope.
 include(icons/CMakeLists.txt)
 add_executable(kdiff3 ${kdiff3_SRCS})
@@ -84,7 +95,6 @@
 
 ########### install files ###############
 
-install( FILES  kdiff3part.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR} )
 install( FILES  kdiff3_part.rc DESTINATION ${KDE_INSTALL_KXMLGUI5DIR}/kdiff3part )
 install( FILES  kdiff3_shell.rc DESTINATION ${KDE_INSTALL_KXMLGUI5DIR}/kdiff3 )
 #install( PROGRAMS  kdiff3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )

=== src/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

find_package(
    Qt5 ${QT_MIN_VERSION}
    REQUIRED
    Test
    )
add_definitions(-DAUTOTEST)

ecm_add_test(connectiontest.cpp
    TEST_NAME "connntiontest"
    LINK_LIBRARIES Qt5::Test
)

ecm_add_test(commentparser.cpp ../CommentParser.cpp
    TEST_NAME "commentparser"
    LINK_LIBRARIES Qt5::Test
)

ecm_add_test(CvsIgnoreListTest.cpp ../ignorelist.cpp ../fileaccess.cpp ../Utils.cpp ../progress.cpp
    TEST_NAME "cvsignorelisttest"
    LINK_LIBRARIES Qt5::Test Qt5::Gui Qt5::Widgets KF5::KIOCore KF5::I18n
)

ecm_add_test(FileAccessTest.cpp ../fileaccess.cpp ../Utils.cpp ../progress.cpp ../ignorelist.cpp
    TEST_NAME "fileaccesstest"
    LINK_LIBRARIES Qt5::Test Qt5::Gui Qt5::Widgets KF5::KIOCore KF5::I18n
)

ecm_add_test(combinertest.cpp
    TEST_NAME "combinertest"
    LINK_LIBRARIES Qt5::Test
)

ecm_add_test(DiffTest.cpp ../diff.cpp ../Logging.cpp ../Utils.cpp ../progress.cpp ../gnudiff_io.cpp ../gnudiff_analyze.cpp ../gnudiff_xmalloc.cpp ../fileaccess.cpp ../SourceData.cpp ../ignorelist.cpp ../CommentParser.cpp
    TEST_NAME "difftest"
    LINK_LIBRARIES Qt5::Test Qt5::Widgets Qt5::Gui KF5::ConfigCore KF5::I18n KF5::WidgetsAddons KF5::Parts KF5::XmlGui KF5::KIOCore
)

=== debian/changelog ===
kdiff3 (1.9.5-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Fri, 04 Mar 2022 21:45:46 +0100

kdiff3 (1.9.4-1) unstable; urgency=medium

  * New upstream release.
  * Mark the xauth, and xvfb build dependencies as nocheck, as they are needed
    only by dh_auto_test.

 -- Pino Toscano <pino@debian.org>  Mon, 22 Nov 2021 23:41:34 +0100

=== debian/control ===
--- 
+++ 
@@ -19,8 +19,8 @@
  libkf5parts-dev (>= 5.37.0~),
  libkf5widgetsaddons-dev (>= 5.37.0~),
  libboost-dev (>= 1.66.0~),
- xauth,
- xvfb,
+ xauth <!nocheck>,
+ xvfb <!nocheck>,
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://kde.org/applications/development/kdiff3

## kdiff3 1.9.6

=== debian/changelog ===
kdiff3 (1.9.6-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.1, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 28 Jun 2022 07:56:45 +0200

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
  libboost-dev (>= 1.66.0~),
  xauth <!nocheck>,
  xvfb <!nocheck>,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://kde.org/applications/development/kdiff3
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdiff3

## kdiff3 1.10.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

#cmake < 3.1 has no sane way of checking C++11 features and needed flags
#CMP0077 is defined in 3.13 or later
cmake_minimum_required(VERSION 3.14 FATAL_ERROR)

project(kdiff3)

option(BUILD_WITH_QT6 OFF)
option(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)
option(CMAKE_CXX_EXTENSIONS ON ) #disable trigraphs in clang/gcc -- officially removed in c++17
option(CMAKE_EXPORT_COMPILE_COMMANDS ON)
#Avaliable as QtVersionOption starting in ECM 5.82.
option(BUILD_WITH_QT6 "Build against Qt 6" OFF)
if (BUILD_WITH_QT6)
    set(QT_MAJOR_VERSION 6)
else()
    set(QT_MAJOR_VERSION 5)
endif()

set(ECM_MIN_VERSION "5.50.0")
set(QT_MIN_VERSION "5.15.2")

set(KF5_MIN_VERSION "5.50.0")

if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.2)
    message(WARNING "gcc < 8.2 is not recomended support is best effort-only.")
endif()


find_package(ECM ${ECM_MIN_VERSION} CONFIG REQUIRED)
set(
    CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${ECM_MODULE_PATH}
)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(FeatureSummary)

include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMOptionalAddSubdirectory)

ecm_setup_version(1.9.70 VARIABLE_PREFIX KDIFF3 VERSION_HEADER ${CMAKE_BINARY_DIR}/src/version.h)

# Some older versions on boost contain a bug that prevents compiling gcc offers a built-in workaround
# but that isn't enough to ship as clang has no such workaround. 1.65 is known to be affected.
#
# 1.71 or later is required for safe_numerics to work on MSVC otherwise we get a link-time error.
find_package(Boost 1.71 REQUIRED)

#needed on craft and possiablely other custom setups.
include_directories(${Boost_INCLUDE_DIRS})

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    CONFIG
    REQUIRED
    COMPONENTS
    Core
    Gui
    Widgets
    PrintSupport
)

find_package(
    KF5 ${KF5_MIN_VERSION}
    REQUIRED
    COMPONENTS
    I18n
    CoreAddons
    Parts
    WidgetsAddons
    Config
    Crash
    OPTIONAL_COMPONENTS
    DocTools
)

set_package_properties(KF5DocTools PROPERTIES PURPOSE "Allows generating and installing docs.")

string(REPLACE "." ";" VERSION_LIST "${KF5_VERSION}")
list(GET VERSION_LIST 0 KF_VERSION_MAJOR)
list(GET VERSION_LIST 1 KF_VERSION_MINOR)
list(GET VERSION_LIST 2 KF_VERSION_PATCH)

option(ENABLE_AUTO "Enable kdiff3's '--auto' flag" ON)
option(ENABLE_CLANG_TIDY "Run clang-tidy if available and cmake version >=3.6" OFF)

set(CMAKE_CXX_STANDARD 17)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    if(ENABLE_CLAZY)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Xclang -plugin-arg-clazy -Xclang level0,level1,no-overloaded-signal,auto-unexpected-qstringbuilder,unused-non-trivial-variable,returning-void-expression,isempty-vs-count,container-inside-loop,assert-with-side-effects")
    endif()
    #Adjust clang specific  warnings
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wshadow -fexceptions")
    set(CLANG_WARNING_FLAGS "-Wno-undef -Wno-trigraphs -Wno-invalid-pp-token -Wno-comment -Wshorten-64-to-32 -Wstring-conversion -Wc++11-narrowing -fstack-protector-all")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${CLANG_WARNING_FLAGS}")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    #Make MSVC obey standard C++ exception handling by destroying all objects going out of scope as a result of the exception.
    #This also separates a Microsoft specific exention SEH which catches non-c++ asynchronous exceptions.
    add_compile_options("/EHsc")
    #Suppress MSVCs min/max macros
    add_definitions(-DNOMINMAX)
    #Suppress Microsoft specfic C4996 "deprecatation" warnings. Not helpful for code intended to run on any other platform.
    add_definitions(-D_CRT_NONSTDC_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS_GLOBALS)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-trigraphs -Wduplicated-cond -Wduplicated-branches -Wshadow -fexceptions")
endif()

#new in cmake 3.6+ integrate clang-tidy
if(ENABLE_CLANG_TIDY)
    find_program(CLANG_TIDY_EXE NAMES "clang-tidy" DOC "Path to clang-tidy executable")
    if(NOT CLANG_TIDY_EXE)
        message(STATUS "clang-tidy not found disabling integration.")
    else()
        message(STATUS "Found clang-tidy: ${CLANG_TIDY_EXE}")
        set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE}" "-header-filter=.*")
    endif()
endif()

set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} ${CMAKE_CXX_FLAGS}")

if(ENABLE_AUTO)
    add_definitions(
        -DENABLE_AUTO
    )
endif()

add_definitions(
    -DQT_DEPRECATED_WARNINGS #Get warnings from QT about deprecated functions.
    -DQT_NO_URL_CAST_FROM_STRING # casting from string to url does not always behave as you might think
    -DQT_RESTRICTED_CAST_FROM_ASCII #casting from char*/QByteArray to QString can produce unexpected results for non-latin characters.
    -DQT_NO_KEYWORDS
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_PROCESS_COMBINED_ARGUMENT_START
    -DQT_DEPRECATED_WARNINGS_SINCE=0x050F00#warn if deprecated at 5.15 or before. Qt default setting is not useful for kdiff3.
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050F00#disable deprecated api for Qt<5.15.
    #Boost 1.74 and possibly others trigger these warnings in boosts own internal headers making
    #the warning useless.
    -DBOOST_ALLOW_DEPRECATED_HEADERS
    #KF5 5.64+ flags
    #Don't warn for API depreciated after 5.70.0 (below as hex.hex.hex number)
    -DKF_DEPRECATED_WARNINGS_SINCE=0x054600
    -DKIOCORE_DEPRECATED_WARNINGS_SINCE=0x054600
    -DKXMLGUI_DEPRECATED_WARNINGS_SINCE=x054600
    -DKF_VERSION_MAJOR=${KF_VERSION_MAJOR}
    -DKF_VERSION_MINOR=${KF_VERSION_MINOR}
    -DKF_VERSION_PATCH=${KF_VERSION_PATCH}
)

add_subdirectory(src)
if(KF5DocTools_FOUND)
    ecm_optional_add_subdirectory(doc)
    kdoctools_install(po)
else()
    message(WARNING "DocTools not found. Docs will not be generated.")
endif()

ki18n_install(po)

add_subdirectory(kdiff3fileitemactionplugin)

if(WIN32)
add_subdirectory(diff_ext_for_kdiff3)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== diff_ext_for_kdiff3/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+#  SPDX-FileCopyrightText: 2003-2006, Sergey Zorin. All rights reserved.
+#  SPDX-FileCopyrightText:  2018-2020 Michael Reeves reeves.87@gmail.com
+#  SPDX-License-Identifier: BSD-2-Clause
+
 # Work around buggy windows sdk headers that prevent certain symbols from being exported the normal way
 # even though they are required exports for shell exentions.
 if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")

=== doc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later

add_subdirectory(en)

=== debian/changelog ===
kdiff3 (1.10.0-1) unstable; urgency=medium

  * New upstream release.
  * Update standards version to 4.6.2, no changes needed.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.14
    - bump Qt packages to 5.15.2
    - bump KF packages to 5.50.0
    - bump libboost-dev to 1.71.0
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Tue, 10 Jan 2023 22:32:12 +0100

=== debian/control ===
--- 
+++ 
@@ -7,21 +7,21 @@
 Build-Depends: debhelper-compat (= 13),
  pkg-kde-tools,
  gettext,
- cmake (>= 3.8~),
- extra-cmake-modules (>= 5.10.0~),
- qtbase5-dev (>= 5.8.0~),
- libkf5config-dev (>= 5.37.0~),
- libkf5coreaddons-dev (>= 5.37.0~),
- libkf5crash-dev (>= 5.37.0~),
- libkf5doctools-dev (>= 5.37.0~),
- libkf5i18n-dev (>= 5.37.0~),
- libkf5kio-dev (>= 5.37.0~),
- libkf5parts-dev (>= 5.37.0~),
- libkf5widgetsaddons-dev (>= 5.37.0~),
- libboost-dev (>= 1.66.0~),
+ cmake (>= 3.14~),
+ extra-cmake-modules (>= 5.50.0~),
+ qtbase5-dev (>= 5.15.2~),
+ libkf5config-dev (>= 5.50.0~),
+ libkf5coreaddons-dev (>= 5.50.0~),
+ libkf5crash-dev (>= 5.50.0~),
+ libkf5doctools-dev (>= 5.50.0~),
+ libkf5i18n-dev (>= 5.50.0~),
+ libkf5kio-dev (>= 5.50.0~),
+ libkf5parts-dev (>= 5.50.0~),
+ libkf5widgetsaddons-dev (>= 5.50.0~),
+ libboost-dev (>= 1.71.0~),
  xauth <!nocheck>,
  xvfb <!nocheck>,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://kde.org/applications/development/kdiff3
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdiff3

## kdiff3 1.10.5

=== debian/changelog ===
kdiff3 (1.10.5-1) unstable; urgency=medium

  * New upstream release.
  * Drop the transitional kdiff3-qt package, no more needed after two Debian
    stable releases.
  * Drop the breaks/replaces for versions older than Debian Bullseye.

 -- Pino Toscano <pino@debian.org>  Mon, 10 Jul 2023 05:38:51 +0200

kdiff3 (1.10.4-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Sun, 11 Jun 2023 22:04:44 +0200

kdiff3 (1.10.2-1) experimental; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sun, 07 May 2023 09:12:42 +0200

kdiff3 (1.10.1-1) experimental; urgency=medium

  * New upstream release.
  * Switch Vcs-* fields to the 'experimental' packaging branch.

 -- Pino Toscano <pino@debian.org>  Fri, 31 Mar 2023 09:29:22 +0200

## kdiff3 1.10.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 #CMP0077 is defined in 3.13 or later
 cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
 
-project(kdiff3)
+project(kdiff3 VERSION 1.10.6)
 
 option(BUILD_WITH_QT6 OFF)
 option(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)
@@ -48,7 +48,7 @@
 include(ECMAddTests)
 include(ECMOptionalAddSubdirectory)
 
-ecm_setup_version(1.9.70 VARIABLE_PREFIX KDIFF3 VERSION_HEADER ${CMAKE_BINARY_DIR}/src/version.h)
+ecm_setup_version(${PROJECT_VERSION} VARIABLE_PREFIX KDIFF3 VERSION_HEADER ${CMAKE_BINARY_DIR}/src/version.h)
 
 # Some older versions on boost contain a bug that prevents compiling gcc offers a built-in workaround
 # but that isn't enough to ship as clang has no such workaround. 1.65 is known to be affected.
@@ -151,7 +151,7 @@
     #Don't warn for API depreciated after 5.70.0 (below as hex.hex.hex number)
     -DKF_DEPRECATED_WARNINGS_SINCE=0x054600
     -DKIOCORE_DEPRECATED_WARNINGS_SINCE=0x054600
-    -DKXMLGUI_DEPRECATED_WARNINGS_SINCE=x054600
+    -DKXMLGUI_DEPRECATED_WARNINGS_SINCE=0x054600
     -DKF_VERSION_MAJOR=${KF_VERSION_MAJOR}
     -DKF_VERSION_MINOR=${KF_VERSION_MINOR}
     -DKF_VERSION_PATCH=${KF_VERSION_PATCH}

=== kdiff3fileitemactionplugin/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdiff3fileitemactionplugin\")

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS KIO
	  WidgetsAddons   # KMessageBox
	)

set(kdiff3_fileitemaction_src kdiff3fileitemaction.cpp ../src/Utils.cpp)

kcoreaddons_add_plugin(kdiff3fileitemaction SOURCES ${kdiff3_fileitemaction_src} JSON kdiff3fileitemaction.json INSTALL_NAMESPACE "kf5/kfileitemaction")
target_link_libraries(kdiff3fileitemaction KF5::I18n KF5::WidgetsAddons KF5::KIOWidgets)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,12 +3,11 @@
 # SPDX-License-Identifier: GPL-2.0-or-later
 
 ########### kdiff3 KPart ###############
-find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS Parts WidgetsAddons)
+
 
 set(kdiff3part_PART_SRCS
    kdiff3_part.cpp
    kdiff3.cpp
-   DirectoryInfo.cpp
    directorymergewindow.cpp
    merger.cpp
    pdiff.cpp
@@ -24,36 +23,40 @@
    common.cpp
    smalldialogs.cpp
    progress.cpp
+   ProgressProxy.cpp
    ProgressProxyExtender.cpp
    PixMapUtils.cpp
    MergeFileInfos.cpp
    Utils.cpp
    selection.cpp
-   ignorelist.cpp
    SourceData.cpp
    Overview.cpp
    Logging.cpp
    FileNameLineEdit.cpp
    MergeEditLine.cpp
    Options.cpp
-   CommentParser.cpp )
+   CommentParser.cpp
+   CvsIgnoreList.cpp
+   CompositeIgnoreList.cpp
+   DirectoryInfo.cpp
+   GitIgnoreList.cpp
+)
 
 ki18n_wrap_ui(kdiff3part_PART_SRCS
     scroller.ui
     opendialog.ui
+    progressdialog.ui
 )
 
 add_library(kdiff3part MODULE ${kdiff3part_PART_SRCS})
 
 set_target_properties(kdiff3part PROPERTIES DEFINE_SYMBOL KDIFF3_PART)
-target_compile_features(kdiff3part PRIVATE ${needed_features})
-target_link_libraries(kdiff3part ${KDiff3_LIBRARIES} KF5::Parts KF5::Crash)
+target_link_libraries(kdiff3part ${Qt5PrintSupport_LIBRARIES} KF5::I18n KF5::CoreAddons KF5::Parts KF5::Crash)
 target_compile_definitions(kdiff3part PRIVATE -DTRANSLATION_DOMAIN=\"kdiff3\")
 
 install(TARGETS kdiff3part DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf5/parts )
 
 ########### kdiff3 executable ###############
-find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS Parts WidgetsAddons Config)
 
 set(kdiff3_SRCS
    main.cpp
@@ -61,15 +64,13 @@
    ${kdiff3part_PART_SRCS}
     )
 
-if(BUILD_TESTING)
-   add_subdirectory( autotests )
-endif()
+ecm_optional_add_subdirectory( autotests )
+
 #cann't use add_subdirectory because it changes the scope.
 include(icons/CMakeLists.txt)
 add_executable(kdiff3 ${kdiff3_SRCS})
 
-target_link_libraries(kdiff3 KF5::ConfigCore KF5::ConfigGui KF5::Parts KF5::Crash ${KDiff3_LIBRARIES} )
-target_compile_features(kdiff3 PRIVATE ${needed_features})
+target_link_libraries(kdiff3 KF5::ConfigCore KF5::ConfigGui KF5::Parts KF5::Crash ${Qt5PrintSupport_LIBRARIES} KF5::I18n KF5::CoreAddons )
 
 # See https://cmake.org/cmake/help/v3.15/prop_tgt/MACOSX_BUNDLE_INFO_PLIST.html
 if(APPLE)
@@ -95,9 +96,8 @@
 
 ########### install files ###############
 
+install( FILES  kdiff3part.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR} )
 install( FILES  kdiff3_part.rc DESTINATION ${KDE_INSTALL_KXMLGUI5DIR}/kdiff3part )
 install( FILES  kdiff3_shell.rc DESTINATION ${KDE_INSTALL_KXMLGUI5DIR}/kdiff3 )
-#install( PROGRAMS  kdiff3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )
 install( PROGRAMS org.kde.kdiff3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )
 install( FILES org.kde.kdiff3.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )
-

=== src/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2018-2021 Michael Reeves reeves.87@gmail.com
# SPDX-License-Identifier: GPL-2.0-or-later
#find_package(QT NAMES Qt5 Qt6  REQUIRED Test)
#set(BUILD_WITH_QT6 OFF)

if(NOT BUILD_WITH_QT6)
    find_package(
        Qt5 ${QT_MIN_VERSION}
        REQUIRED
        COMPONENTS
        Test
    )
else()
    find_package(
        Qt6 ${QT_MIN_VERSION}
        REQUIRED
        COMPONENTS
        Test
    )
endif()
add_definitions(-DAUTOTEST)

ecm_add_test(connectiontest.cpp
    TEST_NAME "connectiontest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test
)

ecm_add_test(commentparser.cpp ../CommentParser.cpp
    TEST_NAME "commentparser"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test
)

ecm_add_test(CvsIgnoreListTest.cpp ../CvsIgnoreList.cpp ../fileaccess.cpp ../Utils.cpp ../ProgressProxy.cpp ../CompositeIgnoreList.cpp
    TEST_NAME "cvsignorelisttest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Widgets KF5::I18n
)

ecm_add_test(FileAccessTest.cpp ../fileaccess.cpp ../Utils.cpp ../ProgressProxy.cpp ../CvsIgnoreList.cpp ../CompositeIgnoreList.cpp
    TEST_NAME "fileaccesstest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Widgets KF5::I18n
)

ecm_add_test(combinertest.cpp
    TEST_NAME "combinertest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test
)

ecm_add_test(CompositeIgnoreListTest.cpp ../CompositeIgnoreList.cpp
    TEST_NAME "CompositeIgnoreListTest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test
)

ecm_add_test(GitIgnoreListTest.cpp ../GitIgnoreList.cpp ../fileaccess.cpp ../Utils.cpp ../ProgressProxy.cpp ../Logging.cpp
    TEST_NAME "GitIgnoreListTest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Widgets KF5::I18n
)

ecm_add_test(datareadtest.cpp ../fileaccess.cpp ../SourceData.cpp ../CommentParser.cpp ../Utils.cpp ../ProgressProxy.cpp ../Logging.cpp
    TEST_NAME "datareadtest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Widgets KF5::Parts KF5::ConfigCore KF5::I18n
)

ecm_add_test(DiffTest.cpp ../diff.cpp ../Logging.cpp ../Utils.cpp ../ProgressProxy.cpp ../gnudiff_io.cpp ../gnudiff_analyze.cpp ../gnudiff_xmalloc.cpp ../fileaccess.cpp ../SourceData.cpp ../CommentParser.cpp
    TEST_NAME "difftest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Widgets KF5::ConfigCore KF5::I18n KF5::Parts
)

ecm_add_test(Diff3LineTest.cpp ../diff.cpp ../gnudiff_io.cpp ../gnudiff_analyze.cpp ../gnudiff_xmalloc.cpp ../Logging.cpp ../Utils.cpp ../ProgressProxy.cpp
    TEST_NAME "diff3linetest"
    LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Test Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Widgets KF5::ConfigCore KF5::I18n
)

=== src/icons/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2002-2011 Joachim Eibl, joachim.eibl at gmx.de
+# SPDX-FileCopyrightText: 2018-2020 Michael Reeves reeves.87@gmail.com
+# SPDX-License-Identifier: GPL-2.0-or-later
+
 set(KDIFF3_PNG_ICONS
      icons/16-apps-kdiff3.png
      icons/22-apps-kdiff3.png

=== debian/changelog ===
kdiff3 (1.10.7-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Wed, 13 Dec 2023 09:43:59 +0100

kdiff3 (1.10.6-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sun, 01 Oct 2023 21:13:53 +0200

=== debian/control ===
--- 
+++ 
@@ -32,8 +32,6 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Recommends: kdiff3-doc
-Breaks: kdiff3-qt (<<1.0)
-Replaces: kdiff3-qt (<<1.0)
 Description: compares and merges 2 or 3 files or directories
  KDiff3 compares two or three input files and shows the differences
  line by line and character by character. It provides an automatic
@@ -42,24 +40,12 @@
  merging as well. KDiff3 also has KIO support, so it can access to
  remote files and compressed archives.
 
-Package: kdiff3-qt
-Architecture: all
-Multi-Arch: foreign
-Depends: kdiff3 (>= ${source:Version}), ${misc:Depends},
-Section: oldlibs
-Description: transistional package for kdiff3
- This is a transitional package. It can safely be removed.
- .
- This version of KDiff3 is not developed anymore, replaced by kdiff3.
-
 Package: kdiff3-doc
 Architecture: all
 Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}
 Recommends: kdiff3
-Breaks: kdiff3 (<= 1.7.90-1)
-Replaces: kdiff3 (<= 1.7.90-1)
 Description: documentation for KDiff3
  KDiff3 compares two or three input files and shows the differences
  line by line and character by character.

=== debian/rules ===
--- 
+++ 
@@ -2,8 +2,16 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+archs_that_need_atomic = armel m68k mipsel powerpc sh4
+ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
+endif
+
 %:
 	dh $@ --with kf5
+
+override_dh_auto_test:
+	xvfb-run -a dh_auto_test
 
 execute_after_dh_auto_install:
 	# drop translations of Windows-only component
